<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<HTML>
<HEAD>
  <TITLE>Manual Installation</TITLE>
</HEAD>
<BODY BGCOLOR="white">
<H1>Manual Installation</H1>

<P>

      The following instructions spell out how to manually install Qmail-Scanner on your system. Simply run <b>./configure</b> as normal without the "--install" option, and then:

</P>

<P>

<div align="center">

<table border="1" cellpadding="5" width="80%" bgcolor="#CCCCCC">
<TR><TD><PRE>
mkdir -p /var/spool/qscan
mkdir -p /var/spool/qscan/quarantine/viruses/tmp /var/spool/qscan/quarantine/viruses/cur /var/spool/qscan/quarantine/viruses/new
mkdir -p /var/spool/qscan/quarantine/spam/tmp /var/spool/qscan/quarantine/spam/cur /var/spool/qscan/quarantine/spam/new
mkdir -p /var/spool/qscan/quarantine/policy/tmp /var/spool/qscan/quarantine/policy/cur /var/spool/qscan/quarantine/policy/new
mkdir -p /var/spool/qscan/working/tmp /var/spool/qscan/working/cur /var/spool/qscan/working/new
mkdir -p /var/spool/qscan/archive/tmp /var/spool/qscan/archive/cur /var/spool/qscan/archive/new
cp quarantine-events.txt /var/spool/qscan/
chown -R qscand:qscand /var/spool/qscan/
cp qmail-scanner-queue.pl /var/qmail/bin/qmail-scanner-queue.pl
chown qscand:qscand /var/qmail/bin/qmail-scanner-queue.pl
chmod 4755  /var/qmail/bin/qmail-scanner-queue.pl #(i.e same perms as qmail-queue, but owned by qscand instead of qmailq)
#run "/var/qmail/bin/qmail-scanner-queue.pl -h" to view the few command-line options there are
/var/qmail/bin/qmail-scanner-queue.pl -z        # to initialize the version file.
/var/qmail/bin/qmail-scanner-queue.pl -g        #to initialize the perlscanner database.
</PRE></TD></TR>
</TABLE>
</P>
&nbsp;
</div>
<p>

     After this is done - as with the automated install - you will have to alter your
      system's Qmail startup scripts (e.g. <b>/service/smtpd/run</b> or <b>/etc/tcpcontrol/smtp.rules</b>) to call <b>QMAILQUEUE</b>
     as documented.


</p>
    <p>If you are wanting to run Qmail-Scanner without the QMAILQUEUE patch, then you're in (almost) unsupported territory as the number of possible problems increases dramatically. Anyway, if you are interested, you should generate the <b>qmail-scanner-queue.pl</b> program with a few different options (see "<b>./configure --help</b>" for details). What follows is an example only:
</p>
    <table border="1" cellpadding="5" width="80%" bgcolor="#CCCCCC"><tr><td><pre>
./configure --debug yes --admin me --domain my.domain --notify psender,nmlvadm \
 --log-details syslog --unzip yes --no-QQ-check  \
 --qmail-queue-binary /var/qmail/bin/qmail-queue.real
</pre>
</td></tr></table>

<p>
      This contains two options not normally used: the "--no-QQ-check" and "--qmail-queue-binary" options. The first stops <b>./configure</b> checking for the presence of the QMAILQUEUE patch, and the second tells Qmail-Scanner where the "real" Qmail <b>qmail-queue</b> binary is. In this case it is moved to <b>/var/qmail/bin/qmail-queue.real</b>. Once this is done, the resulting <b>qmail-scanner-queue.pl</b> program  can be copied onto <b>/var/qmail/bin/qmail-queue</b>. But be careful - infinite loop territory...

<p><font size="-3"><b>Last Updated:</b> <?php echo   date ("l dS of F Y h:i:s A",filemtime($_SERVER[SCRIPT_FILENAME])). " GMT"; ?></font>
<P>
</BODY>
</HTML>
