#!/bin/bash
# Qmail-Scanner-Report Mailer 1.0
# by Aizudin Ali Yeon (aizudin - cnc.net.my)
#
# Place this file at /etc/cron.daily/ 
# Please do this first! 
#
# mkdir /var/spool/qscan/log
# chown qscand.qscand /var/spool/qscan/log
#
# Tested with qmail-scanner 2.01st

export DATE="`date +%d_%m_%Y:%H:%M`"

# admin user email id
EMAIL="user@hostname"

# Subject for email
SUBJECT="$(date) Qmail-Scanner Report of $(hostname) "

# Os Specifc tweaks do not change anything below ;)
OS="$(uname)"
TRUE="1"
if [ "$OS" == "FreeBSD" ]; then
        TEMPFILE="$(mktemp /tmp/$(basename $0).tmp.XXX)"
elif [ "$OS" == "Linux" ]; then
        TEMPFILE="$(mktemp)"
fi

#Generate report
echo "DAILY QMAIL SCANNER REPORT" >> $TEMPFILE
echo "--------------------------" >> $TEMPFILE
echo " " >> $TEMPFILE
echo "Hostname: $(hostname)" >> $TEMPFILE
echo "Report Date & Time : $(date)" >> $TEMPFILE
echo " " >> $TEMPFILE
echo "Scan activities for last 24 hours" >> $TEMPFILE
/var/spool/qscan/log-report.sh /var/spool/qscan/qmail-queue.log >> $TEMPFILE

#Send an email
mail -s "$SUBJECT" "$EMAIL" < $TEMPFILE

#Remove temp file and move qmail-queue to old log db
rm -f $TEMPFILE
mv /var/spool/qscan/qmail-queue.log /var/spool/qscan/log/qmail-queue.log-`echo $DATE`
echo "Qmail-Scanner Report Sent To" "$EMAIL"