sub avast_scanner {
  #avastlite scanner
  &debug("avast: starting scan of directory \"$ENV{'TMPDIR'}\"...");

  my ($start_avast_time)=[gettimeofday];
  my ($DD,$avast_status,$eavast_status,$stop_avast_time,$avast_time);

  &debug("run $avastlite_binary -n  $ENV{'TMPDIR'} 2>&1");

  $DD=`$avastlite_binary -n $ENV{'TMPDIR'} 2>&1`;
  $avast_status=$?;
  $eavast_status=($avast_status >> 8);

  &debug("--output of avastlite was:\n$DD--");

  if ( $eavast_status > 0) {
    if ($eavast_status == 1 && $DD =~ /(.*)\t+\[L\]\t+([^\s]+)/m) {
      $quarantine_description=$2;
      &debug("There be a virus! ($quarantine_description)");
      &minidebug("avast: there be a virus! ($quarantine_description)");
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="avast:".substr($quarantine_event,0,$QE_LEN);
      $description .= "\n---avast results ---\n$DD";
    } elsif ($eavast_status <= 24) {
      #This is OK,  corrupt files are let through
    } else {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("avast: corrupt or unknown avastlite scanner error or memory/resource/perms problem - exit status $avast_status/$eavast_status");
    }
  } else {
    if ($avast_status > 0) {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("avast: corrupt or unknown avastlite scanner error or memory/resource/perms problem - exit status $avast_status/$eavast_status");
    }
  }
  #Should always be some output. Always error on exception
  $DD=~s/\n//g;
  if ($DD eq "" ) {
    &error_condition("avast: corrupt or unknown avastlite scanner error or memory/resource/perms problem - exit status $avast_status/$eavast_status, but no output!");
  }
  
  $stop_avast_time=[gettimeofday];
  $avast_time = tv_interval ($start_avast_time, $stop_avast_time);
  &debug("avast: finished scan of dir \"$ENV{'TMPDIR'}\" in $avast_time secs");
  &minidebug("avast: finished scan in $avast_time secs");
}
