sub esets_scanner {
  # ESET NOD32 is now esets_cli
  # st: adapted from nod32_scanner, thanks to Apro Krisztian 'apro - rndsoft.hu'
  &debug("esets: starting scan of directory \"$ENV{'TMPDIR'}\"...");
  my ($start_esets_time)=[gettimeofday];
  my ($DD,$esets_status,$stop_esets_time,$esets_time,$esets_verbose);
  
  $DD=`$esets_binary --subdir $ENV{'TMPDIR'}    2>&1`;
  $esets_status=($? >> 8);
  &debug("--output of esets was:\n$DD--");
  if ( $esets_status =~ /^(2|3)$/ && $DD =~ /action="(rejected|discarded)"$/m) {
      $description .= "\n---esets results ---\n$DD";
      $DD =~ s/virus="is OK"//g;
      $DD =~ /virus="(.*)"/;
      $quarantine_description=$1;
      &debug("There be a virus! ($quarantine_description)");
      &minidebug("esets: there be a virus! ($quarantine_description)");
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="esets:".substr($quarantine_event,0,$QE_LEN);
  } elsif ( $esets_status !~ /^0$/ ) {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("corrupt or unknown esets scanner error or memory/resource/perms/conf problem - exit status $esets_status");
  }
  $stop_esets_time=[gettimeofday];
  $esets_time = tv_interval ($start_esets_time, $stop_esets_time);
  &debug("esets: finished scan of dir \"$ENV{'TMPDIR'}\" in $esets_time secs");
  &minidebug("esets: finished scan in $esets_time secs");
}
