sub iscan_scanner {
  #Trend scanner
  my ($start_iscan_time)=[gettimeofday];
  &debug("iscan: starting scan of directory \"$ENV{'TMPDIR'}\"...");
  my ($DD,$iscan_status,$eiscan_status,$stop_iscan_time,$iscan_time,$iscan_verbose);
  $iscan_verbose="-v" if ($DEBUG);

  &debug("run  $iscan_binary -p/etc/iscan/ -za -a -u -nl $iscan_verbose $ENV{'TMPDIR'}  2>&1");
  $DD=`$iscan_binary -p/etc/iscan/ -za -a -u -nl $iscan_verbose $ENV{'TMPDIR'}  2>&1`;
  $iscan_status=$?;
  $eiscan_status=($iscan_status >> 8);

  &debug("--output of iscan was:\n$DD--");

  if ( $DD =~ /\*\*\*\s+Found(.*) in file/m  ) {
    $quarantine_description=$1;
    &debug("There be a virus! ($quarantine_description)");
    &minidebug("iscan: there be a virus! ($quarantine_description)");
    ($quarantine_event=$quarantine_description)=~s/\s/_/g;
    $quarantine_event="ISCAN:".substr($quarantine_event,0,$QE_LEN);
    $description .= "\n---iscan results ---\n$DD";
  } elsif ( $eiscan_status > 0 || ($eiscan_status == 0 && $iscan_status > 0) ) {
    #This implies a corrupt set of DAT files or resource problems...
    &error_condition("corrupt or unknown Trend scanner error or memory/resource/perms problem - exit status $iscan_status/$eiscan_status");
  }
  $stop_iscan_time=[gettimeofday];
  $iscan_time = tv_interval ($start_iscan_time, $stop_iscan_time);
  &debug("iscan: finished scan of dir \"$ENV{'TMPDIR'}\" in $iscan_time secs");
  &minidebug("iscan: finished scan in $iscan_time secs");
}
