sub log_msg {
  my($msgtype,$status,$elapsed_time,$msgsize,$frm,$recips,$subj,$msgid,$attachs)=@_;
  my ($msg,$file);


  my $syslogtype='mail|info';

  if ($log_details eq "syslog") {

    $msgtype =~ s/\s/_/g;
    $msgtype .= "[$$]";
    $status =~ s/\s//g;
    $syslogtype='mail|warning' if ($status !~ /^Clear/);
    $elapsed_time =~ s/\s//g;
    $elapsed_time=0.0 if (!$elapsed_time);
    $elapsed_time=substr($elapsed_time,0,8);
    $frm =~ s/\s/_/g;
    $frm='<>' if (!$frm);
    $frm=substr($frm,0,100);
    $recips =~ s/\s/\|/g;
    $recips='<>' if (!$recips);
    $recips=substr($recips,0,100);
    $subj =~ s/\s/_/g;
    $subj='<>' if (!$subj);
    $subj=substr($subj,0,80);
    $msgid =~ s/\s/_/g;
    $msgid = '<>' if (!$msgid);
    $msgid=substr($msgid,0,80);
    $msgsize =~ s/\s//g;
    $attachs =~ s/\s$//g;
    #Sub any spaces for underscores then swap tabs for spaces,
    #syslog doesn't like tabs, so spaces in filenames have to go...
    $attachs =~ s/\ /_/g;
    $attachs =~ s/\t/ /g;
    if (!$attachs) {
      foreach $file (@uufile_list,@zipfile_list,@attachment_list) {
	$file =~ s/\s/_/g;
	$attachs .= "$file ";
      }
      $attachs =~ s/\s+$//g;
    }
    $attachs="$file_id-unpacked:$msg_size" if (!$attachs);
    #$attachs=substr($attachs,0,100);
    $msg = "$status $elapsed_time $msgsize $frm $recips $subj $msgid $attachs";
    #Do final santity check and remove all low-end chars - like NULL
    #I have no idea how some older syslogs would react to such things...
    $msg =~s/[\x00-\x09]//g;
    $msg =~ s/%/%%/g;
    #Now ensure syslog record isn't larger than max syslog size of 1024 chars
    $msg=substr($msg,0,1024);
    eval {
      $SIG{ALRM} = sub { die "Maximum time writing to syslog exceeded. syslog is hung/broken." };
      alarm 10;
      eval {
	syslog($syslogtype,"$msgtype: $msg");
      };
      if ($@) {
	setlogsock('inet');
	syslog('mail|info',"$msgtype: $msg");
      }
    };
    #The message is delivered - so no temp failure here - you just have to lose the log entry...
    alarm 0;
  } else {
    #No error checking - inability to write a log report shouldn't
    #stop the mail getting through!

    $msgtype =~ s/\t/ /g;
    $status =~ s/\s//g;
    $elapsed_time =~ s/\s//g;
    $elapsed_time=0 if (!$elapsed_time);
    $frm =~ s/\t/ /g;
    $frm='<>' if (!$frm);
    $recips =~ s/\t/ /g;
    $recips='<>' if (!$recips);
    $subj =~ s/\t/ /g;
    $subj='<>' if (!$subj);
    $msgid =~ s/\t/ /g;
    $msgid = '<>' if (!$msgid);
    $msgsize =~ s/\s//g;
    $attachs =~ s/\s$//g;
    $attachs =~ s/\t/ /g;
    $attachs="$file_id-unpacked:$msg_size"  if (!$attachs);
    $msg = "$status\t$elapsed_time\t$msgsize\t$frm\t$recips\t$subj\t$msgid\t$attachs";
    my $nowtime = strftime("%a, %d %b %Y %H:%M:%S %Z", localtime(time));
    open LOGMSG, ">>$logdir/$log_details";
    print LOGMSG "$nowtime\t$msg\n";
    close LOGMSG;
  }
  &debug("$msgtype: $msg");
}


