sub uvscan_scanner {
  #MacAfee scanner
  &debug("uvscan: starting scan of directory \"$ENV{'TMPDIR'}\"...");
  my ($start_uvscan_time)=[gettimeofday];
  my ($DD,$uvscan_status,$euvscan_status,$stop_uvscan_time,$uvscan_time,$uvscan_verbose);
  $uvscan_verbose="-v" if ($DEBUG);

  &debug("run $uvscan_binary  $uvscan_verbose -r --secure --fam --unzip --macro-heuristics  $ENV{'TMPDIR'}    2>&1");
  $DD=`$uvscan_binary  $uvscan_verbose -r --secure --fam --unzip --macro-heuristics  $ENV{'TMPDIR'} 2>&1`;
  $uvscan_status=$?;
  $euvscan_status=($uvscan_status >> 8);

  &debug("--output of uvscan was:\n$DD--");
  if ( $euvscan_status > 0 ) {
    if ($DD =~ /^\s+Found(.*)$/m) {
      $quarantine_description=$1;
      &debug("There be a virus! ($quarantine_description)");
      &minidebug("uvscan: there be a virus! ($quarantine_description)");
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="UVSCAN:".substr($quarantine_event,0,$QE_LEN);
      $description .= "\n---uvscan results ---\n$DD";
      #	   print "virus \"$virus\"\n";
    } else {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("corrupt or unknown MacAfee scanner error or memory/resource/perms problem - exit status $uvscan_status/$euvscan_status");
    }  
  } elsif ($uvscan_status > 0 || $DD =~ /file could not be opened/) {
    #This implies a corrupt set of DAT files or resource problems...
    #MacAfee is sooo broken that it exits error status zero on an 
    #out of memory error - so we have to kludge and look for 
    #"file could not be opened" to catch it

    &error_condition("corrupt or unknown MacAfee scanner error or memory/resource/perms problem - exit status $uvscan_status/$euvscan_status");
  }
  $stop_uvscan_time=[gettimeofday];
  $uvscan_time = tv_interval ($start_uvscan_time, $stop_uvscan_time);
  &debug("uvscan: finished scan of dir \"$ENV{'TMPDIR'}\" in $uvscan_time secs");
  &minidebug("uvscan: finished scan in $uvscan_time secs");
}
