sub vexira_scanner {
  #RAV scanner
  &debug("vexira_scanner: starting scan of directory \"$ENV{'TMPDIR'}\"...");
  my ($start_vexira_time)=[gettimeofday];
  my ($cmd,$DD,$vexira_status,$evexira_status,$stop_vexira_time,$vexira_time,$vexira_verbose);
  my $vexira_options = "--allfiles -s -z -nolnk -noboot -nombr -nodef  ";
  $vexira_verbose="--listall" if ($DEBUG);

  $cmd="$vexira_binary $vexira_options $ENV{'TMPDIR'} 2>&1";
  &debug("vexira_scanner: $cmd");
  $DD =`$cmd 2>&1`;
  $vexira_status=$?;
  $evexira_status=($vexira_status >> 8);

  &debug("vexira_scanner: $DD, exit status $evexira_status");
  if ($evexira_status > 0 ) {
    if ($DD =~ /^\s+ALERT: \[([^\]]+)\]/m) {
      $quarantine_description=$1;
      &debug("vexira_scanner: There be a virus! ($quarantine_description)");
      &minidebug("vexira_scanner: there be a virus! ($quarantine_description)");
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="VEX:".substr($quarantine_event,0,$QE_LEN);
      $description .= "\n---vexira results ---\n$DD";
    } else {
      &debug("vexira_scanner: Whoops! Something went wrong - requeue");
      &error_condition("corrupt or unknown Vexira scanner error or memory/resource/perms problem - exit status $vexira_status/$evexira_status");
    }
  } else {
    #Check for other things Vexira notices...
    if ($DD =~ /WARNING: archive not completely scanned: (contents exceed \d+ (levels of recursion|bytes))/) {
      $quarantine_description="Resource attack - $1";
      &debug("vexira_scanner: $quarantine_description");
      $quarantine_event="VEX:Resource_attack";
      $description .= "\n---vexira results ---\n$DD";
    } elsif ($vexira_status > 0) {
      &debug("vexira_scanner: Whoops! Something went wrong - requeue");
      &error_condition("corrupt or unknown Vexira scanner error or memory/resource/perms problem - exit status $vexira_status/$evexira_status");
    }
  }
  $stop_vexira_time=[gettimeofday];
  $vexira_time = tv_interval ($start_vexira_time, $stop_vexira_time);
  &debug("vexira_scanner: finished scan of dir \"$ENV{'TMPDIR'}\" in $vexira_time secs");
  &minidebug("vexira_scanner: finished scan in $vexira_time secs");
}
